﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public class EAnnotation : EModelElement, INotifyPropertyChanged
    {
        #region ModelElement

        private EModelElement mModelElement;

        public EModelElement ModelElement
        {
            get
            {
                return mModelElement;
            }
            set
            {
                if (mModelElement != value)
                {
                    var old = mModelElement;
                    mModelElement = value;

                    if (old != null && old.Annotations.Contains(this)) old.Annotations.Remove(this);
                    if (value != null && !value.Annotations.Contains(this)) value.Annotations.Add(this);

                    OnModelElementChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnModelElementChanged(EventArgs e)
        {
            EventHandler handler = ModelElementChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("ModelElement");
        }

        public event EventHandler ModelElementChanged;

        #endregion
        
    }
}
