﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public class EClass : EClassifier, INotifyPropertyChanged
    {
        public EClass()
        {
            this.Features = new EClassFeatureCollection(this);
            this.Operations = new EClassOperationsCollection(this);
            this.DerivedTypes = new EClassDerivedCollection(this);
            this.SuperTypes = new EClassSuperTypeCollection(this);
        }

        #region IsAbstract

        private bool mIsAbstract;

        public bool IsAbstract
        {
            get
            {
                return mIsAbstract;
            }
            set
            {
                if (mIsAbstract != value)
                {
                    mIsAbstract = value;
                    OnIsAbstractChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIsAbstractChanged(EventArgs e)
        {
            EventHandler handler = IsAbstractChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("IsAbstract");
        }

        public event EventHandler IsAbstractChanged;

        #endregion

        #region IsInterface

        private bool mIsInterface;

        public bool IsInterface
        {
            get
            {
                return mIsInterface;
            }
            set
            {
                if (mIsInterface != value)
                {
                    mIsInterface = value;
                    OnIsInterfaceChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIsInterfaceChanged(EventArgs e)
        {
            EventHandler handler = IsInterfaceChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("IsInterface");
        }

        public event EventHandler IsInterfaceChanged;

        #endregion

        public EClassFeatureCollection Features { get; private set; }
        public EClassOperationsCollection Operations { get; private set; }
        public EClassDerivedCollection DerivedTypes { get; private set; }
        public EClassSuperTypeCollection SuperTypes { get; private set; }
    }
}
