﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public class EDataType : EClassifier, INotifyPropertyChanged
    {
        #region IsSerializable

        private bool mIsSerializable;

        public bool IsSerializable
        {
            get
            {
                return mIsSerializable;
            }
            set
            {
                if (mIsSerializable != value)
                {
                    mIsSerializable = value;
                    OnIsSerializableChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIsSerializableChanged(EventArgs e)
        {
            EventHandler handler = IsSerializableChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("IsSerializable");
        }

        public event EventHandler IsSerializableChanged;

        #endregion
        
    }
}
