﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NMF.Interop.Ecore
{
    public class EEnumLiteral : ENamedElement
    {
        #region Value

        private int mValue;

        public int Value
        {
            get
            {
                return mValue;
            }
            set
            {
                if (mValue != value)
                {
                    mValue = value;
                    OnValueChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnValueChanged(EventArgs e)
        {
            EventHandler handler = ValueChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Value");
        }

        public event EventHandler ValueChanged;

        #endregion

        #region Enum

        private EEnum mEnum;

        public EEnum Enum
        {
            get
            {
                return mEnum;
            }
            set
            {
                if (mEnum != value)
                {
                    var old = mEnum;
                    mEnum = value;

                    if (old != null && old.Literals.Contains(this)) old.Literals.Remove(this);
                    if (value != null && !value.Literals.Contains(this)) value.Literals.Add(this);

                    OnEnumChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnEnumChanged(EventArgs e)
        {
            EventHandler handler = EnumChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Enum");
        }

        public event EventHandler EnumChanged;

        #endregion
        
    }
}
