﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public abstract class ENamedElement : EModelElement, INotifyPropertyChanged
    {
        #region Name

        private string mName;

        public string Name
        {
            get
            {
                return mName;
            }
            set
            {
                if (mName != value)
                {
                    mName = value;
                    OnNameChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnNameChanged(EventArgs e)
        {
            EventHandler handler = NameChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Name");
        }

        public event EventHandler NameChanged;

        #endregion
        
    }
}
