﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public class EObject : INotifyPropertyChanged
    {
        #region Id

        private string mId;

        public string Id
        {
            get
            {
                return mId;
            }
            set
            {
                if (mId != value)
                {
                    mId = value;
                    OnIdChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIdChanged(EventArgs e)
        {
            EventHandler handler = IdChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Id");
        }

        public event EventHandler IdChanged;

        #endregion

        #region INotifyPropertyChanged

        protected void OnPropertyChanged(string propertyName)
        {
            OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }



        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, e);
        }

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
