﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public class EParameter : ETypedElement, INotifyPropertyChanged
    {
        #region Operation

        private EOperation mOperation;

        public EOperation Operation
        {
            get
            {
                return mOperation;
            }
            set
            {
                if (mOperation != value)
                {
                    var old = mOperation;
                    mOperation = value;

                    if (old != null && old.Parameters.Contains(this)) old.Parameters.Remove(this);
                    if (value != null && !value.Parameters.Contains(this)) value.Parameters.Add(this);

                    OnOperationChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnOperationChanged(EventArgs e)
        {
            EventHandler handler = OperationChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Operation");
        }

        public event EventHandler OperationChanged;

        #endregion
        
    }
}
