﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public class EReference : EStructuralFeature, INotifyPropertyChanged
    {

        #region IsContainment

        private bool mIsContainment;

        public bool IsContainment
        {
            get
            {
                return mIsContainment;
            }
            set
            {
                if (mIsContainment != value)
                {
                    mIsContainment = value;
                    OnIsContainmentChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIsContainmentChanged(EventArgs e)
        {
            EventHandler handler = IsContainmentChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("IsContainment");
        }

        public event EventHandler IsContainmentChanged;

        #endregion

        #region ResolveProxies

        private bool mResolveProxies;

        public bool ResolveProxies
        {
            get
            {
                return mResolveProxies;
            }
            set
            {
                if (mResolveProxies != value)
                {
                    mResolveProxies = value;
                    OnResolveProxiesChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnResolveProxiesChanged(EventArgs e)
        {
            EventHandler handler = ResolveProxiesChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("ResolveProxies");
        }

        public event EventHandler ResolveProxiesChanged;

        #endregion

        #region Opposite

        private EReference mOpposite;

        public EReference Opposite
        {
            get
            {
                return mOpposite;
            }
            set
            {
                if (mOpposite != value)
                {
                    var old = mOpposite;
                    mOpposite = value;

                    if (old != null) old.Opposite = null;
                    if (value != null) value.Opposite = this;

                    OnOppositeChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnOppositeChanged(EventArgs e)
        {
            EventHandler handler = OppositeChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Opposite");
        }

        public event EventHandler OppositeChanged;

        #endregion
        
    }
}
