﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace NMF.Interop.Ecore
{
    public abstract class ETypedElement : ENamedElement, INotifyPropertyChanged
    {
        #region IsOrdered

        private bool mIsOrdered;

        public bool IsOrdered
        {
            get
            {
                return mIsOrdered;
            }
            set
            {
                if (mIsOrdered != value)
                {
                    mIsOrdered = value;
                    OnIsOrderedChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIsOrderedChanged(EventArgs e)
        {
            EventHandler handler = IsOrderedChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("IsOrdered");
        }

        public event EventHandler IsOrderedChanged;

        #endregion

        #region IsUnique

        private bool mIsUnique;

        public bool IsUnique
        {
            get
            {
                return mIsUnique;
            }
            set
            {
                if (mIsUnique != value)
                {
                    mIsUnique = value;
                    OnIsUniqueChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnIsUniqueChanged(EventArgs e)
        {
            EventHandler handler = IsUniqueChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("IsUnique");
        }

        public event EventHandler IsUniqueChanged;

        #endregion

        #region LowerBound

        private int mLowerBound;

        public int LowerBound
        {
            get
            {
                return mLowerBound;
            }
            set
            {
                if (mLowerBound != value)
                {
                    mLowerBound = value;
                    OnLowerBoundChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnLowerBoundChanged(EventArgs e)
        {
            EventHandler handler = LowerBoundChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("LowerBound");
        }

        public event EventHandler LowerBoundChanged;

        #endregion

        #region UpperBound

        private int mUpperBound;

        public int UpperBound
        {
            get
            {
                return mUpperBound;
            }
            set
            {
                if (mUpperBound != value)
                {
                    mUpperBound = value;
                    OnUpperBoundChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnUpperBoundChanged(EventArgs e)
        {
            EventHandler handler = UpperBoundChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("UpperBound");
        }

        public event EventHandler UpperBoundChanged;

        #endregion

        #region Type

        private EClassifier mType;

        public EClassifier Type
        {
            get
            {
                return mType;
            }
            set
            {
                if (mType != value)
                {
                    mType = value;
                    OnTypeChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnTypeChanged(EventArgs e)
        {
            EventHandler handler = TypeChanged;
            if (handler != null) handler(this, e);
            OnPropertyChanged("Type");
        }

        public event EventHandler TypeChanged;

        #endregion
        
    }
}
