﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

using NMF.Interop.Ecore.Transformations;
using NMF.Transformations;
using System.Reflection;
using NMF.Transformations.Core;

namespace NMF.Interop.Ecore
{
    public static class EcoreInterop
    {

        private static XmlSerializer serializer = new XmlSerializer(typeof(Serialization.EPackage));
        private static EcoreSerializerTransformation serializerTransform = new EcoreSerializerTransformation();
        private static EPackage2ClassesTransformation epackages2Classes = new EPackage2ClassesTransformation();
        private static Classes2EPackageTransformation classes2EPackages = new Classes2EPackageTransformation();

        public static EPackage LoadPackageFromFile(Stream input)
        {
            var package = serializer.Deserialize(input) as Serialization.EPackage;

            if (package == null) return null;

            var transformed = TransformationEngine.Transform<Serialization.EPackage, EPackage>(package, serializerTransform);

            return transformed;
        }

        public static System.CodeDom.CodeCompileUnit CreateCompilationUnit(EPackage input)
        {
            return TransformationEngine.Transform<EPackage, System.CodeDom.CodeCompileUnit>(input, epackages2Classes);
        }

        public static EPackage LoadPackageFromTypes(Assembly assembly)
        {
            return LoadPackageFromTypes(assembly.GetTypes());
        }

        public static EPackage LoadPackageFromTypes(Type[] types)
        {
            //TODO: implement
            return null;
        }

    }
}
