﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;

namespace NMF.Serialization
{
    public interface ITypeSerializationInfo : IXmlElement, IStringConvertible
    {
        ICollection<IPropertySerializationInfo> AttributeProperties { get; }
        ICollection<IPropertySerializationInfo> ElementProperties { get; }

        ICollection<ITypeSerializationInfo> BaseTypes { get; }

        Type Type { get; }

        IPropertySerializationInfo[] ConstructorProperties { get; }

        ConstructorInfo Constructor { get; }

        bool IsIdentified { get; }

        IPropertySerializationInfo IdentifierProperty { get; }

        bool IsCollection { get; }

        ITypeSerializationInfo CollectionItemType { get; }

        void AddToCollection(object collection, object item);
    }
}
